package cn.ibizlab.core.extensions.service;

import cn.ibizlab.core.rule.service.impl.RuleEngineServiceImpl;
import lombok.extern.slf4j.Slf4j;
import cn.ibizlab.core.rule.domain.RuleEngine;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Primary;
import java.util.*;

/**
 * 实体[规则引擎] 自定义服务对象
 */
@Slf4j
@Primary
@Service("RuleEngineExService")
public class RuleEngineExService extends RuleEngineServiceImpl {

    @Override
    protected Class currentModelClass() {
        return com.baomidou.mybatisplus.core.toolkit.ReflectionKit.getSuperClassGenericType(this.getClass().getSuperclass(), 1);
    }

    /**
     * [Run:运行] 行为扩展
     * @param et
     * @return
     */
    @Override
    @Transactional
    public RuleEngine run(RuleEngine et) {
        return super.run(et);
    }
}

